import java.util.Scanner;

//I'm a computer science sophomore and this program checks if we have n bulbs, the bulbs that will be on after we send m iterations.
public class Bulbs {
	
	public static void main(String[] args) {
		Scanner cmd = new Scanner(System.in);
		System.out.print("Enter the number of bulbs followed by the number of iterations you wanna try: ");
		int num = cmd.nextInt();
		int iter = cmd.nextInt();
		boolean[] bulbs = new boolean[num];
		for(int i=1; i<=iter; i++) {
			//sets true to each bulb that should be on and false to each one that should be false after i iterations
			for(int j=1; j<=num;j++) {
				//checks the bulb in the position j.
				if(j%i==0){
					//if j is a multiple of i then the bulb at the position j should be toggled (in the array its j-1 since we start at 0).
					bulbs[j-1]=!bulbs[j-1];
				}
			}
		}
		String toPrint="";
		for(int i=0;i<num;i++) {
			//checks each element in the array.
			if(bulbs[i]){
				//if the position at i is true then the bulb there should be on after the n iteration.
				toPrint+=(i+1)+", ";
			}
		}
		toPrint = toPrint.substring(0, toPrint.length()-2);
		System.out.printf("The bulbs that will be on after %d iteration are: %s", num, toPrint);
	}
	
}
