import java.awt.Color;
import java.awt.Graphics;
import java.util.Scanner;


//I'm a computer science sophomore and this program asks the user to prompt the number num of bulbs he wants to toggle after itr iterations and draws a representation of it.
public class BulbsInAction {
	
	public static void main(String[] args) {
		DrawingPanel d= new DrawingPanel(800, 100);
		Scanner cmd = new Scanner(System.in);
		System.out.print("Enter the number of bulbs followed by the number of iterations you wanna try: ");
		int num = cmd.nextInt();
		int iter = cmd.nextInt();
		boolean[] bulbs = new boolean[num];
		for(int i=1; i<=iter; i++){
			//i is the iteration number at each iteration we toggle some bulbs with the togglebulbs method and draw them with drawbulbs method with 400ms between each iteration
			toggleBulbs(bulbs, i);
			drawBulbs(bulbs, d);
			d.sleep(400);
		}
		
	}
	public static void toggleBulbs(boolean[] b, int n){
		//this method toggles the appropriate bulbs in the nth iteration
		for(int j=1; j<=b.length;j++) {
			if(j%n==0){
				//if j is a multiple of n then the bulb at the position j should be toggled (in the array its j-1 since we start at 0 in the array).
				b[j-1]=!b[j-1];
			}
		}
	}
	public static void drawBulbs(boolean[] b, DrawingPanel d) {
		//draws the bulbs depending on the values in the boolean array.
		Graphics g = d.getGraphics();
		d.setBackground(Color.GRAY);
		int x;
		for(int i=0; i<b.length; i++) {
			//checks which bulb should be on(set color to yellow) and the off (set color to black).
			if(b[i]){
				g.setColor(Color.YELLOW);
			} else {
				g.setColor(Color.BLACK);
			}
			x=20+10*i;
			g.drawOval(x, 50, 5, 5);
			if((i+1)%2==0){
				//draws the even indexes above the bulbs.
				g.drawString(""+(i+1), x, 47 );
			} else{
				//draws the odd indexes below the bulbs.
				g.drawString(""+(i+1), x, 69 );
			}
		}
	}
	
}
