import java.awt.Color;
import java.awt.Graphics;
import java.util.Scanner;


//im a sophomore computer science student, this program draws 3 different checker boards based on the user's input.
public class CheckerBoard {

	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		System.out.printf("Enter three sizes for the checker board: ");
		int size1 = scan.nextInt();
		int size2 = scan.nextInt();
		int size3 = scan.nextInt();
		DrawingPanel d = new DrawingPanel(500, 500);
		Graphics g = d.getGraphics();
		Color c1 = Color.RED;
		Color c2 = Color.BLACK;
		board(30, 200, size1, g, c1, c2);//30 is the starting point
		board(200, 200, size2, g, c1, c2); //200=30+100(size)+70(space)
		board(370, 200, size3, g, c1, c2);//370=200+100+70
	}
	public static void board (int x, int y, int n, Graphics g, Color c1, Color c2){
		//method that draws the board depending on the integer n since we want the lower left square to be always red.
		g.setColor(c2);
		g.fillRect(x, y, 100, 100);
		g.setColor(c1);
		//each 2 non consecutive lines have the same pattern(starting and ending colors) depending on n we know how to start for the lower left square to stay red.
		if(n%2!=0) {
			for(int i=y; i<y+100; i+=2*100/n){
				for(int j=x; j<x+100; j+=2*100/n) {
					g.fillRect(j, i, 100/n, 100/n);	
					}
				}
			for(int i=y+100/n; i<y+100; i+=2*100/n){
				for(int j=x+100/n; j<x+100; j+=2*100/n) {
					g.fillRect(j, i, 100/n, 100/n);	
					}
				}
		}else {
			for(int i=y; i<y+100; i+=2*100/n) {
				for(int j=x+100/n; j<x+100; j+=2*100/n) {
					g.fillRect(j, i, 100/n, 100/n);	
					}
			}
			for (int i=y+100/n; i<y+100; i+=2*100/n) {
				for(int j=x; j<x+100; j+=2*100/n) {
					g.fillRect(j, i, 100/n, 100/n);	
					}
			}
		}

	}
	
}
