import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;


//I'm a computer science sophomore and this program takes a file full of dictionaries separated by bunch of "-" and prints the number of words in each dictionary that can be split to two words that already exists in the dictionary.
public class Dictionnary {
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner cmd = new Scanner(System.in);
		System.out.printf("Enter the name of the dictionary file: ");
		File f = new File(cmd.next());
		Scanner scan = new Scanner(f);
		Scanner checkLength = new Scanner(f);//scanner that reads the file and gets the length of each dictionary(number of lines/words in each one).
		String str="";
		String[] use = new String [50000];//the max of one dictionnary.
		int index = 0;
		
		while(true){
			//loop that stops break after it sees "+++".
			str=checkLength.nextLine();
			if(str.contains("-")){
				//"---" the line after the finish of the dictionary.
				for(int i=0; i<index; i++){
					//sets each word in the dictionary in the array.
					use[i]=scan.nextLine();
				}
				print(use, index);//prints the number of words that can be split to two in the current dictionary.
				scan.nextLine();//skips the line containing"---" in the scanner file.
				index=0;//setting index to 0 for the next dictionary so each time we call print we check the current dictionary only.
			} else if(str.contains("+++")){
				//last dictionary so we do the same thing then break.
				for(int i=0; i<index; i++){
					//sets each word in the dictionary in the array.
					use[i]=scan.nextLine();
				}
				print(use, index);//prints the number of words that can be split to two in the current dictionary.
				break;
			} else{
				index++;//each time the checklength scanner reads a word that is not "---" nor "+++" the index(i.e. length) increment.
			}
		}
		
	}
				
	public static void print (String[] str, int length) {
		//takes a dictionary and prints the number of words in it that can be split to two.
		int toReturn = 0;
		String use="";
		
		for(int i=0; i<=length; i++) {
			//checks each word in the dictionnary (first length Strings in the array).
			use=str[i];
			if(check(str, use, length)){
				//if the method check returns true then the word can be split to two words and both of them are in the dictionary.
				toReturn++;
			}
		}
		System.out.println(toReturn);
	}
	public static boolean check(String str[], String use, int length) {
		//checks if the word can be split to two words in in the current dictionary.
		String temp="";
		String compare="";
		for(int i=0;i<=length;i++){
			//checks the whole dictionary.
			compare=str[i];
			if(use.startsWith(compare)&&compare.length()<use.length()){
				//if the string at position i is the start of string use word we set temp to be that word then checks if temp is in the dictionary.
				temp=use.substring(use.indexOf(compare.length()));
				for(int j=0;j<length;j++){
					//checks if temp is in the dictionary.
					if(str[j]==temp){
						return true;
					}
				}
			} else if (use.endsWith(compare)&&compare.length()<use.length()){
				//if the string at position i is the end of the string use we set temp to be that word then checks if temp is in the dictionary.
				temp=use.substring(0,use.length()-compare.length()-1);
				for(int j=0; j<str.length; j++){
					//checks if temp is in the dictionary.
					if(str[j]==temp){
						return true;
					}
				}
			}
		}
		return false;
	}
}

