
//I'm a computer science sophemore and this class create a book with 4 instances, and contains methods from getters, setters, and toString in addition to three comparing methods that compare two books.
public class Book {
	private String title;
	private String authorName;
	private int year;
	private int edition;
	
	public Book(String title, String authorName, int year) {
		//constructor that sets 3 instances to the given parameters and set the edition to 1.
		this.title = title;
		this.authorName = authorName;
		this .year = year;
		edition=1;
	}
	
	public Book(String title, String authorName, int year, int edition) {
		//constructor that sets all the instances to the given parameters.
		this.title = title;
		this.authorName = authorName;
		this .year = year;
		this.edition = edition;
	}
	
	public String getTitle() {
		//returns the title of the book.
		return  this.title;
	}
	
	public String getAuthorName(){
		//returns the author name of the book.
		return  this.authorName;
	}
	
	public int getYear() {
		//returns the year the book was published in.
		return  this.year;
	}
	
	public int getEdition() {
		//returns the edition of the book.
		return  this.edition;
	}
	
	public void setTitle(String title) {
		//sets the title of the book to the parameter.
		this.title=title;
	}
	
	public void setAuthorName(String authorName) {
		//sets the author name of the book to the parameter.
		this.authorName = authorName;
	}
	
	public void setYear(int year) {
		//sets the year of publishing the book to the parameter.
		this.year = year;
	}
	
	public void setEdition (int edition) {
		//sets the edition of the book to the parameter.
		this.edition = edition;
	}
	
	public boolean equals (Book book) {
		//returns true if the two books are the same and false otherwise.
		if(this.authorName==book.authorName&&this.title==book.title&&this.year==book.year&&this.edition==book.edition){
			return true;
		} else {
			return false;
		}
	}
	
	public String toString(){
		//returns a string representation of the book.
		return "The book's title: " + title + "\nThe book's author name: " + authorName + "\nThe book was published in: " + year + "\nThe book's edition: " + edition;
	}
	
	public int compareToByTitle(Book book) {
		//compare the two books by titles then by author names then by editions; return -1 if the current book's title comes before the one in the parameter, 1 if it comes after, else it returns 0;
		int max;
		if(this.title.length()>book.title.length()){
			max=book.title.length();
		} else{
			max = this.title.length();
		}
		
		for(int i=0; i<max; i++){
			if(this.title.charAt(i)<book.title.charAt(i)){
				return -1;
			} else if(this.title.charAt(i)<book.title.charAt(i)){
				return 1;
			}
		}
		if(this.authorName.length()>book.authorName.length()){
			max=book.authorName.length();
		} else{
			max = this.authorName.length();
		}
		
		for(int i=0; i<max; i++){
			if(this.authorName.charAt(i)<book.authorName.charAt(i)){
				return -1;
			} else if(this.authorName.charAt(i)<book.authorName.charAt(i)){
				return 1;
			}
		}
		if(this.edition<book.edition){
			return -1;
		} else if(this.edition>book.edition){
			return 1;
		}
		return 0;
	}
	
	public int compareToByAuthor (Book book) {
		//compare the two books by author names then title then edition; return -1 if the current book's author name comes before the one in the parameter, 1 if it comes after, else it returns 0;
		int max;
		if(this.authorName.length()>book.authorName.length()){
			max=book.authorName.length();
		} else{
			max = this.authorName.length();
		}
		
		for(int i=0; i<max; i++){
			if(this.authorName.charAt(i)<book.authorName.charAt(i)){
				return -1;
			} else if(this.authorName.charAt(i)<book.authorName.charAt(i)){
				return 1;
			}
		}
		if(this.title.length()>book.title.length()){
			max=book.title.length();
		} else{
			max = this.title.length();
		}
		
		for(int i=0; i<max; i++){
			if(this.title.charAt(i)<book.title.charAt(i)){
				return -1;
			} else if(this.title.charAt(i)<book.title.charAt(i)){
				return 1;
			}
		}
		if(this.edition<book.edition){
			return -1;
		} else if(this.edition>book.edition){
			return 1;
		}
		return 0;
	}
	

}
