import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;


//I'm a computer science sophemore and this program checks a file containing the results from rolling a dice n times, and print the chi-square of that dice followed by if its a fair or unfair die.
public class FairDie {
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner user = new Scanner(System.in);
		System.out.printf("Enter name of a file that contains results from rolling a single die: ");
		String fileName = user.next();
		Scanner scan = new Scanner(new File(fileName));
		int numOfRolls = scan.nextInt();
		double chiSquare = 1/6.0*Math.pow(numOfRolls, 2);
		int use=0;
		int[] count = new int[6];
		int compare;
		for(int i=0; i<count.length; i++){
			//for every integer in the array.
			for(int j=1; j<=numOfRolls; j++){
				//checks all the file and increment the integers in the array everytime compare is equal to i+1.
				compare=scan.nextInt();
				if(compare==i+1){
					count[i]++;
				}
			}
		}
		for(int i=1; i<=6; i++){
			//get the sumnation to multiply in the chi-square.
			use+=Math.pow(6.0*count[i-1]-numOfRolls, 2);
		}
		chiSquare*=use;
		System.out.printf("chi-square = %f \n", chiSquare);
		if(chiSquare<0.02){
			System.out.printf("Fair Die");
		} else {
			System.out.printf("Unfair Die");
		}

	}


}
