import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Scanner;

//I'm a computer science sophomore and this program reads a file full of integers and fills them in an array to sort them then prints the sorted version of the array.
public class Sorting {
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner cmd = new Scanner (System.in);
		System.out.printf("Enter the name of the sorting input file: ");
		File file = new File(cmd.next());
		Scanner scan1 = new Scanner (file);
		Scanner use = new Scanner (file);
		use.nextInt();
		int lines = scan1.nextInt();
		int length=0;
		while(scan1.hasNextInt()) {
			// gets the number of integers in the file.
			length++;
			scan1.nextInt();
		}
		int[] toSort = new int[length-lines];//each line starts with an integer so the array to be sorted should have length equal to the number of integers minus the number of lines.
		
		String str="";
		while(use.hasNextLine()) {
			//fill the integers in the file in a string.
			use.nextInt();
			str+=use.nextLine() + " ";
		}
		Scanner scan2 = new Scanner(str);
		int index=0;
		while(scan2.hasNextInt()){
			//fill the integers of the string in the array to be sorted.
			toSort[index]=scan2.nextInt();
			index++;
		}
		Arrays.sort(toSort);//sort the array.
		String toPrint = Arrays.toString(toSort);//take the string representation of the sorted array and sorted in a string.
		toPrint.replaceAll(",", "");//delete all the commas.
		toPrint=toPrint.substring(1,toPrint.length()-2);// delete "[" and "]" from the string for a neater display.
		System.out.print(toPrint);
	}
	
}
