import java.util.Arrays;


//I'm a computer science sophomore and this program tests a bunch of methods on 2D double arrays.
public class TwoDArrays {
	
	public static void main(String[] args) {
		double[][] test = new double[3][3];
		double sum=0;
		
		test=generate2D(3,3);
		System.out.println(Arrays.deepToString(test));
		System.out.println("the sum of all entries in this array is: " + sum(test));
		System.out.println("the sum of entries in the lower block of this array is: " + sumLowerBlock(test));
		
		test=generate2D(3,3, 5, 13);
		System.out.println(Arrays.deepToString(test));
		System.out.println("the sum of all entries in this array is: " + sum(test));
		System.out.println("the sum of entries in the lower block of this array is: " + sumLowerBlock(test));
		
	}
	public static double[][] generate2D(int n, int m) {
		//generate a double array with n rows and m columns filled with values between 0 and 1.
		double[][] twoD = new double[n][m];
		for(int i=0; i<n; i++){
			//fill each row.
			for(int j=0; j<m; j++){
				//fill each column.
				twoD[i][j]=Math.random();
			}
		}
		return twoD;
	}
	public static double[][] generate2D(int n, int m, int min, int max) {
		//generate a double array with n rows and m columns filled with values between min and max.
		double[][] twoD = new double[n][m];
		for(int i=0; i<n; i++){
			//fill each row.
			for(int j=0; j<m; j++){
				//fill each column.
				twoD[i][j]=Math.random()*(max-min)+min;
			}
		}
		return twoD;
	}
	public static double sum (double[][] a) {
		//get the sum of all entries in the array a.
		double sum=0;
		for(int i=0; i<a.length; i++){
			//go into each row.
			for(int j=0; j<a[0].length; j++){
				//goes into each column in the current row.
				sum+=a[i][j];//adds each entries to the sum.
			}
		}
		return sum;
	}
	public static double sumLowerBlock (double[][] a) {
		//get the sum of the lower block of the array a.
		double sum=0;
		for(int i=0; i<a.length; i++){
			//goes into each row.
			for(int j=0; j<a[0].length; j++){
				//goes into each column in the current row.
				if(i>=j){
					//checks if the [i][j] is a part of the lower block and adds it to the sum if it is.
					sum+=a[i][j];
				}
			}
		}
		return sum;
	}

	
}
